<?php
/**
* @version		$Id: linkcloak.php 10381 2008-06-01 03:35:53Z pasamio $
* @package		Joomla Link Cloaker
* @copyright	Copyright (C) 2008 www.brewsterware.com - All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent('onPrepareContent', 'plgContentLinkCloak');

/**
 * Plugin that cloaks affiliate links in content via Javascript.
 *
 * @return boolean True on success.
 */
function plgContentLinkCloak(&$row, &$params, $page=0)
{
	if (is_object($row)) {
		return plgLinkCloak($row->text, $params);
	}
	return plgLinkCloak($row, $params);
}

/**
 * Cloak affiliate links in text via Javascript.
 *
 * @param string The string to be cloaked.
 * @return boolean True on success.
 */
function plgLinkCloak(&$text, &$params)
{
	// Simple performance check to determine whether bot should process further.
	if (JString::strpos($text, '[CLOAK') === false) {
		return true;
	}

	$plugin = & JPluginHelper::getPlugin('content', 'linkcloak');

	$pattern = '~\[CLOAK\](.*?)\[/CLOAK\]~i';

	while (preg_match($pattern, $text, $regs, PREG_OFFSET_CAPTURE)) {
		// This is the text that we are going to replace later.
		$findText = $regs[0][0];

		// cloak the url
		$replaceText = cloakURL( $regs[1][0] );

		// replace the cloaked url in the text
		$text = str_replace( $findText, $replaceText, $text );
	}

	$pattern = '~\[CLOAK statustext="([^"]*?)"\](.*?)\[/CLOAK\]~i';

	while (preg_match($pattern, $text, $regs, PREG_OFFSET_CAPTURE)) {
		// This is the text that we are going to replace later.
		$findText = $regs[0][0];

		// get the status bar text
		$statusBarText = $regs[1][0];

		// cloak the url
		$replaceText = cloakURL( $regs[2][0], $statusBarText );

		// replace the cloaked url in the text
		$text = str_replace( $findText, $replaceText, $text );
	}

	return true;
}

function cloakURL( $url, $statustext = '' )
{
	$javascript = "<a onMouseOut=\"return window.status='';\" onMouseOver=\"return window.status='$statustext';\" ";

	// get the quote marks
	$quotePos = strpos($url, 'href=');
	$quote = $url{$quotePos + 5};

	// Get the href..
	preg_match("~href=$quote([^$quote]*?)$quote~", $url, $href_matches);
	$newHref = encode_url($href_matches[1]);

	// Replace the url
	$replaceText = str_replace($href_matches[1], $newHref, $url);

	// add in the javascript
	return str_replace('<a ', $javascript, $replaceText);

}

function encode_url( $string )
{
	$ent = null;

	// encode each character
	for ($i = 7 ; $i < strlen($string) ; $i++)
		$ent[$i] = "&#" . ord($string{$i}) . ";";

	// if there is nothing in the array then dont return anything
	if (sizeof($ent) < 1)
		return "";

	// convert the array into a string and return it
	return 'http://' . implode("", $ent);
}

